"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const codeeditor_1 = require("@jupyterlab/codeeditor");
const signaling_1 = require("@phosphor/signaling");
class Editor extends codeeditor_1.CodeEditorWrapper {
    constructor(editorFactory) {
        super({
            model: new codeeditor_1.CodeEditor.Model(),
            factory: editorFactory.newInlineEditor,
        });
        this._executeRequest = new signaling_1.Signal(this);
        this.editor.addKeydownHandler((_, evt) => this._onKeydown(evt));
        this.addClass("p-Sql-Editor");
    }
    get executeRequest() {
        return this._executeRequest;
    }
    _onKeydown(event) {
        if (event.shiftKey && event.key === "Enter") {
            this._executeRequest.emit(this.model.value.text);
            return true;
        }
        return false;
    }
}
exports.Editor = Editor;
