import { SingletonLayout, Widget } from '@phosphor/widgets';
import { Message } from '@phosphor/messaging';
declare namespace Responses {
    type Type = ErrorResponse | SuccessResponse;
    interface ErrorResponse {
        responseType: "error";
        responseData: ErrorResponseData;
    }
    interface SuccessResponse {
        responseType: "success";
        responseData: SuccessResponseData;
    }
    interface ErrorResponseData {
        message: string;
    }
    type SuccessResponseData = {
        hasRows: false;
    } | {
        hasRows: true;
        keys: Array<string>;
        rows: Array<Array<any>>;
    };
    function match<U>(response: Type, onSuccessWithRows: (keys: Array<string>, rows: Array<Array<any>>) => U, onSuccessNoRows: () => U, onError: (_: ErrorResponseData) => U): U;
}
export declare class ResponseWidget extends Widget {
    constructor();
    readonly layout: SingletonLayout;
    private item;
    setCurrentWidget(widget: Widget): void;
    onResize(msg: Message): void;
    fitCurrentWidget(): void;
    setResponse(response: Responses.Type): void;
}
export {};
